#ifdef CTECH_EXPORTS
#define CTECH_API __declspec(dllexport)
#else
#define CTECH_API __declspec(dllimport)
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

//------------------------------------
// CtCheckOBD:
//  No parameters
//  Returns XOBD memory map struct if XOBD is running
//    Returns NULL if XOBD is not running
CTECH_API XOBD2Share * __stdcall CtCheckOBD(void);

//------------------------------------
// CtCheckGPS:
//  No parameters
//  Returns XPort GPSData memory map struct if XPort is running
//    Returns NULL if XPort is not running
CTECH_API GPSData * __stdcall CtCheckGPS(void);

//------------------------------------
// CtXOBDCommand:
//   hWndClient: HWND handle of client window for identification message transmissions
//   wMsg: WM_USER message ID that client will identify as XOBD messages
//   wFlags: See XSCFlag_ in XOBD.h
//   dwData: Data sent depending on wFlags
//  Returns false if command can't be sent
CTECH_API int __stdcall CtXOBDCommand(HWND hWndClient, UINT wMsg, DWORD wFlags, DWORD dwData);

//------------------------------------
// CtSetPid:
//   dwMode: Only Mode 1 supported (TODO)
//   dwPid: PID of mode to enable
//	Note: PIDs are cleared when completed, and must be set again
CTECH_API int __stdcall CtSetPid(DWORD dwMode, DWORD dwPid);

//------------------------------------
// CtXOBDState:
//   No parameters
//   Returns XOBD process state (See 'enum ELMState' in XOBD.h)
CTECH_API int __stdcall CtXOBDState();

//------------------------------------
// CtReadPidData:
//   dwMode: Only Mode 1/5 supported (TODO)
//   dwPid: PID of mode to read
//   dwWord: word of PID to read (0 or 1)
CTECH_API int __stdcall CtReadPidData(DWORD dwMode, DWORD dwPid, DWORD dwWord);

//------------------------------------
// CtReadCounter:
//   No parameters
//   Returns 8-bit counter that changes at the end of each request cycle
CTECH_API int __stdcall CtReadCounter();

//------------------------------------
// CtReadQueue:
//   No parameters
//   Returns 8-bit value which is number of requests in queue
CTECH_API int __stdcall CtReadQueue();

#ifdef __cplusplus
};
#endif /* __cplusplus */
